#define FINAL
//#define DEBUG

#ifdef DEBUG
 #define DISPLAY_RING
 #define VERBOSE
 //#define NO_DISPLAY
#endif
#ifdef FINAL 
 //#define DISPLAY_RING
 //#define VERBOSE
 #define NO_DISPLAY
#endif

#define EN_DIST_ROUGE

#include "ks0108.h"

#ifndef NO_DISPLAY
	#include "glcd.h"
#endif

#include "i2c.h"
#include "rprintf.h"

#include "timer.h"

volatile u08 position=0;
u08 p1=0,p2=0;
volatile u08 distance=0;
u08 d1=0,d2=0, mytime=0;

//#define LOCAL_ADDR	0xA0

u08 i2cSlaveTransmitService(u08 transmitDataLengthMax, u08* transmitData);

#define setA sbi(PORTB,PB1) ;
#define setB sbi(PORTB,PB4) ; //
#define setC sbi(PORTB,PB0) ;
#define clearA cbi(PORTB,PB1) ;
#define clearB cbi(PORTB,PB4) ; //
#define clearC cbi(PORTB,PB0) ;

#define valueof_X1 inb(PORTB,PB2)
#define valueof_Y1 inb(PORTB,PB5)
#define valueof_X2 inb(PORTB,PB7)
#define valueof_Y2 inb(PORTB,PB3)

#define FOR(I,FROM,A,TO,B) for(I=A;I<=B;I++)

#ifndef NO_DISPLAY
	#define AT(l,c) glcdSetAddress(c,LINE ## l);
	#define PRINT(s) glcdPutStr(s);
#endif

#ifndef NO_DISPLAY
	#define FILTER_TPS 5
	#define MEM_TPS 3
	#define TPS_THR 2
#else
    #define FILTER_TPS 15
    #define MEM_TPS 10
	#define TPS_THR 5
#endif


u08 capteurs[32];

u08 tps[32];
u08 mem[32];
u08 memt[32];
//#define resu capteurs
u08 resu[32];

u08 GetMax();

u08 nn1[32];
u08 nn2[32];

u08 last_p;


u08 bonus=0;

u08 nnPosition() {
 	u08 k,t,u,m,p1,p2,p3,p4;
	u08 g=0;

	t = 0; k = 1; u = 0;

	// + effet mmoire
	for(m=0;m<=31;m++) nn1[m] = (2*resu[m]+2*resu[((m+1)>31?0:m+1)]+nn1[m])/5;

	// + effet mmoire
	for(m=0;m<=31;m++) nn2[m] = (2*nn1[m]+2*nn1[((m+1)>31?0:m+1)]+nn2[m])/5;
	
	// zone 4
	p4=0;
	for(m=8;m<=15;m++) {
		p4+=nn2[m];
	}

	// zone 3
	for(m=16;m<=23;m++) {
		p3+=nn2[m];
	}

	// zone 2
	for(m=0;m<=7;m++) {
		p2+=nn2[m];
	}

	// zone 1
	for(m=24;m<=31;m++) {
		p1+=nn2[m];
	}

	k = ( 4*p4 + 3*p3 + 2*p2 + p1 ) / (p4+p3+p2+p1);
	k = (2*k +last_p) / 3;

	last_p = k;

	return k;
	
}

u08 GetMax() {
 	u08 k,t,u,m;

	t = 0; k = 1; u = 0;
	
	// zone 4
	for(m=8;m<=15;m++) u += resu[m];
	if (u >= t) { t = u; k = 4; }

	// zone 3
	u=0;
	for(m=16;m<=23;m++) u += resu[m];
	if (u >= t) { t = u; k = 3; }

	// zone 2
	u=0;
	for(m=0;m<=7;m++) u += resu[m];
	if (u >= t) { t = u; k = 2;	}

	// zone 1
	u=0;
	for(m=24;m<=31;m++) u += resu[m];
	if (u >= t) { t = u; k = 1; }

	return k;
}

time_since_detect = 0;
timeout = 0;


u08 GetDist(int zone,int conf) {
	u08 dist=0,m,min,max,u,d1=0,d2=0,d3=0,d4=0;

	//if (zone==4) {
		for(m=8-4;m<=15+4;m++) d1 += resu[m];
	//} else if (zone==3) {
		for(m=16-4;m<=23+4;m++) d2 += resu[m];
	//} else if (zone==2) {
		for(m=28;m<=0;m++) d3 += resu[m];
		for(m=1;m<=7+4;m++) d3 += resu[m];
	//} else {
		for(m=24-4;m<=31;m++) d4 += resu[m];
		for(m=0;m<=0+4;m++) d4 += resu[m];
	//}

	//m = (dist+2*((conf*8)/28))/3; // 28 = max conf
	u=0;
	for(m=0;m<=31;m++) 
		u += resu[m];

	if(u>=8 && (
	    	(d4>0 && d3>0) || (d1>0 && d2>0) ||
	    	(d1>0 && d3>0) || (d4>0 && d1>0) ||
	    	(d2>0 && d3>0))
		) {
		  if(u<15) {
		  	u=15; // burst!
		  } 
	}

	//timeout
	if(u>7 && time_since_detect > 16) {
		  if(u<15) {
		  	u=15; // burst!
		  } 
	} else if(u>2 && time_since_detect > 12) {
		  if(u<8) {
		  	u=8; // burst!
		  } 
	}


#ifdef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 4, 0 ) 
			rprintf("Test: %d u=%d", time_since_detect,u);
  #endif
#endif


	return u;
}




u08 Filter(u08 data, u08 i) {
	u08 t,r;
    t = data;

    if (tps[i] > TPS_THR)
      r = 1;
    else
      r = 0;

    if (t == 0 && mem[i] == 1 && tps[i] < FILTER_TPS) {
      tps[i]++;
	  memt[i]=0;
	}
    if (t == 1 && mem[i] == 0 && tps[i] < FILTER_TPS) {
      tps[i]++;
	  memt[i]=0;
	}
    if (t == 0 && mem[i] == 0 && tps[i] > 0) {
	  if (memt[i] > MEM_TPS) {
        tps[i]--;
      } else {
	  	memt[i]++;
	  }
	}
    if (t == 1 && mem[i] == 1 && tps[i] > 0) {
	  if (memt[i] > MEM_TPS) {
        tps[i]--;
      } else {
	  	memt[i]++;
	  }
    }

    mem[i] = t;

    resu[i] = r;

	return r;
}


#define sVert  PORTD |= (1<<PD0)
#define cVert  PORTD &= ~(1<<PD0)
#define sRouge PORTD |= (1<<PD1)
#define cRouge PORTD &= ~(1<<PD1)



void i2cSlaveReceiveService(u08 receiveDataLength, u08* receiveData){
}


#define NB_ECHANTILLONS 90

u08 nb0minX1;
u08 nb0minX2;
u08 nb0minY1;
u08 nb0minY2;
u08 nb1minX1;
u08 nb1minX2;
u08 nb1minY1;
u08 nb1minY2;

u08 nb0minX1cur;
u08 nb0minX2cur;
u08 nb0minY1cur;
u08 nb0minY2cur;
u08 nb1minX1cur;
u08 nb1minX2cur;
u08 nb1minY1cur;
u08 nb1minY2cur;

int main() {
	u08 i,j,x,y,max;
	u08 nb_erreurs=0;

	PORTB=0x00;
	DDRB=0x53;

	DDRD |= 3;
	//cbi(PORTC,2); //rouge 38
	//cbi(PORTC,3); //vert 34
	//sbi(DDRC,2); //rouge 38
	//sbi(DDRC,3); //vert 34

	//cbi(PORTC,2); //rouge 38

#ifndef NO_DISPLAY
	glcdInit();
#endif

	i2cInit();
	timerInit();

#ifndef NO_DISPLAY
	rprintfInit(glcdWriteChar);
#endif

	// set the Slave Transmit Handler function
	// (this function will run whenever a master somewhere else on the bus
	//  attempts to read data from us as a slave)
	i2cSetLocalDeviceAddr(/*0xA0*/0xA8,0/* ne pas repondre au broadcast I2C*/);
	i2cSetSlaveTransmitHandler( i2cSlaveTransmitService );
	i2cSetSlaveReceiveHandler( i2cSlaveReceiveService );
	

	//AT ( 1, -60 ) PRINT("Pos:")
	//AT ( 2, -60 ) PRINT("Ang:")

	//glcdSetAddress(4,LINE2);
	//glcdWriteChar('H');

	//i =1;
	while(1) {
		u08 lastX1=0,lastX2=0,lastY1=0,lastY2=0;

		int conf=0;

		// desactiver les LED du portC!
		FOR ( i, from, 0, to, 7 ) { // nombre de quadri capteurs.
			u08 x1=0,y1=0,x2=0,y2=0,k,l;
			u08 b;

			// on positionne l'adresse

			if (i & 1) { setA } else { clearA }
			if (i & 2) { setB } else { clearB }
			if (i & 4) { setC } else { clearC }

			// chantillonner

#define GET_X1_Y1_X2_Y2() \
				b = PINB; \
				x1 = (b & (1<<2)) >> 2;	\
				y1 = (b & (1<<5)) >> 5; \
				x2 = (b & (1<<7)) >> 7; \
				y2 = (b & (1<<3)) >> 3;

		// reconnaissance prcise de notre signal sur 
		// la porteuse.

			// compte le nombre de 1 et de 0 conscutifs minimum
			nb1minX1 = 0;
			nb0minX1 = 0;
			nb1minX2 = 0;
			nb0minX2 = 0;
			nb1minY1 = 0;
			nb0minY1 = 0;
			nb1minY2 = 0;
			nb0minY2 = 0;

			FOR( k, from, 0, to, 9) { // nombre d'chantillons
				GET_X1_Y1_X2_Y2(); // 10s


				// TODO: attente
				//sRouge;
				for(l=0;l<150;l++) // delay <1ms
					asm("nop");
				//cRouge;



				// pour X1
#define COUNT(_x1_,_X1_) \
				if(_x1_==1) { \
					nb1min ## _X1_ ++; \
				} else { /* mme chose pour le zro */ \
					nb0min ## _X1_ ++; \
				}

				COUNT(x1,X1);
				COUNT(x2,X2);
				COUNT(y1,Y1);
				COUNT(y2,Y2);

				lastX1 = x1;
				lastX2 = x2;
				lastY1 = y1;
				lastY2 = y2;
			}

#ifdef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 3, 0 ) 
			rprintf("time=%d",time_since_detect);
  #endif
#endif
			/*AT ( 3, 0 ) 
			rprintf("x1:%d,x2=%d",nb1minX1,nb1minX2);
			AT ( 4, 0 ) 
			rprintf("y1:%d,y2=%d",nb1minY1,nb1minY2 );
			AT ( 5, 0 ) 
			rprintf("x1:%d,x2=%d",nb0minX1,nb0minX2);
			AT ( 6, 0 ) 
			rprintf("y1:%d,y2=%d",nb0minY1,nb0minY2 );
			//*/


#define NB_TICKS_HIGH 4
#define NB_TICKS_LOW 5

			/*if(
			nb1minX1 == NB_TICKS_HIGH ||
			//nb1minY1 == NB_TICKS_HIGH ||
			//nb1minX2 == NB_TICKS_HIGH ||
			//nb1minY2 == NB_TICKS_HIGH
			) {
				sRouge;
			} else {
				cRouge;
			}*/
			/*for(k=0;k<nb1minX1;k++) {
				sRouge;
				for(l=0;l<15;l++) // delay <1ms
					asm("nop");
				cRouge;
				for(l=0;l<15;l++) // delay <1ms
					asm("nop");
			}*/

#define INDEX_X1 16+2*i
#define INDEX_X2 16+2*i+1
#define INDEX_Y1 2*i
#define INDEX_Y2 2*i+1

			if(4<=nb1minX1 && nb1minX1<=5) {
				if(5<=nb0minX1 && nb0minX1<=6) {
					conf += capteurs[INDEX_X1] = Filter(1,INDEX_X1);
				} else capteurs[INDEX_X1] = Filter(0,INDEX_X1);
			} else capteurs[INDEX_X1] = Filter(0,INDEX_X1);
			if(4<=nb1minX2 && nb1minX2<=5) {
				if(5<=nb0minX2 && nb0minX2<=6) {
					conf += capteurs[INDEX_X2] = Filter(1,INDEX_X2);
				} else capteurs[INDEX_X2] = Filter(0,INDEX_X2);
			} else capteurs[INDEX_X2] = Filter(0,INDEX_X2);
			capteurs[INDEX_Y1] = 0;
			if(4<=nb1minY1 && nb1minY1<=5) {
				if(5<=nb0minY1 && nb0minY1<=6) {
					conf += capteurs[INDEX_Y1] = Filter(1,INDEX_Y1);
				} else capteurs[INDEX_Y1] = Filter(0,INDEX_Y1);
			} else capteurs[INDEX_Y1] = Filter(0,INDEX_Y1);
			capteurs[INDEX_Y2] = 0;
			if(4<=nb1minY2 && nb1minY2<=5) {
				if(5<=nb0minY2 && nb0minY2<=6) {
					conf += capteurs[INDEX_Y2] = Filter(1,INDEX_Y2);
				} else capteurs[INDEX_Y2] = Filter(0,INDEX_Y2);
			} else capteurs[INDEX_Y2] = Filter(0,INDEX_Y2);


			//conf = 1;

			/*capteurs[16+2*i] = ( nb1minX1 == NB_TICKS_HIGH && nb0minX1 == NB_TICKS_LOW );
			capteurs[2*i] = ( nb1minY1 == NB_TICKS_HIGH && nb0minY1 == NB_TICKS_LOW );
			capteurs[16+2*i+1] = ( nb1minX2 == NB_TICKS_HIGH && nb0minX2 == NB_TICKS_LOW );
			capteurs[2*i+1] = ( nb1minY2 == NB_TICKS_HIGH && nb0minY2 == NB_TICKS_LOW );
			//*/

 			/*conf += (capteurs[2*i] = Filter(y1, 2*i));
			conf += (capteurs[2*i+1] = Filter(y2, 2*i+1));
			conf += (capteurs[16+2*i] = Filter(x1, 16+2*i));
			conf += (capteurs[16+2*i+1] = Filter(x2, 16+2*i+1));
			//*/

			/*capteurs[2*i] = y1;
			capteurs[16+(2*i)] = x1;
			capteurs[(2*i)+1] = y2;
			capteurs[16+(2*i)+1] = x2; //x1*/
			
		} // on ritre sur 8 quadri-capteurs.


#ifdef DISPLAY_RING
  #ifndef NO_DISPLAY
		x = 20; y = 40;
		FOR ( i, from, 0, to, 1 ) {
			FOR ( j, from, 0, to, 15 ) {

				if(capteurs[16*i+j]) {
					glcdSetDot(x,y);
				} else {
					glcdClearDot(x,y);
				}

				if(i<1) x+=2; else x-=2;
				if(i<1 && j<7) y+=2; else if(i<1 && j>8) y-=2;
				if(i>=1 && j<7) y-=2; else if(i>=1 && j>8) y+=2;

			}
		}
  #endif
#endif

		/*if (conf>=29) {
			cVert;

#ifdef EN_DIST_ROUGE
			sRouge;
#endif

			distance = -2;
			position = 6;
#ifdef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 1, 0 ) 
			rprintf("Noisy!");
			AT ( 2, 0 ) 
			rprintf("D-2 P=6");
  #endif
#endif
		} else */
		time_since_detect++;
		if (conf!=0) {
			sVert;

			// calcul de la zone
			//position = nnPosition();
			position = GetMax();
#ifdef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 2, 0 ) 
			rprintf("Zone: %d", position);
  #endif
#endif

			distance = GetDist(position,conf);
			//distance = (d1 + d2 + distance) / 3;
			//d2 = d1;
			//d1 = distance;
#ifdef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 1, 0 ) 
			rprintf("Dist: %d ", distance);
  #endif
#endif

#ifdef EN_DIST_ROUGE
			if (distance >= 15) {
				sRouge;
			} else {
				cRouge;
			}
#endif

#ifndef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 1, 0 ) 
			rprintf("D%d P%d  ", distance,position);			
  #endif
#endif
			nb_erreurs = 0;
		} else {

			if(nb_erreurs > 15) {
				cVert;

#ifdef EN_DIST_ROUGE
				cRouge;
#endif

				distance = -1;
				position = 5;

				time_since_detect = 0;

#ifdef VERBOSE
  #ifndef NO_DISPLAY
				AT ( 1, 0 ) 
				rprintf("No sig.");
				AT ( 2, 0 ) 
				rprintf("D-1 P=5");
  #endif
#endif
			} else {
				nb_erreurs++;

				distance = (d1 + d2 + distance) / 3;
				d2 = d1;
				d1 = distance;

#ifdef VERBOSE
  #ifndef NO_DISPLAY
			AT ( 1, 0 ) 
			rprintf("Dist: %d ", distance);
  #endif
#endif

			}
			
		}

		mytime++;
		if(mytime==2)
			mytime=0;
		
	}


}

//volatile u08 bal=0;

u08 i2cSlaveTransmitService(u08 transmitDataLengthMax, u08* transmitData)
{
	//u08 i;

/*	if (bal==0) {
		sRouge;
		bal=1;
	} else {
		cRouge;
		bal=0;
	}*/

	// this function will run when a master somewhere else on the bus
	// addresses us and wishes to read data from us

	// copy the local buffer to the transmit buffer
	*transmitData++ = position;
	*transmitData = distance;
	
	return 2; // number of data to transmit to master : position and angle
}
